#include <stm32f10x_lib.h>

#define AdresseCommande 0x4A	/*Adresse de commande du circuit intgr MCP23017, reli aux broches  R/S ,  R/W ,  E, et  DB0    DB7  de l'afficheur alphanumrique*/

/* Buffer of data to be received by I2C1 */
unsigned char Buffer_Rx1[255];

/* Buffer of data to be transmitted by I2C1 */
unsigned char Buffer_Tx1[255] = {0xFF};

unsigned char Buffer_Test_1[3] = {0x00, 0x00, 0xAA};

unsigned char Buffer_Test_2[3] = {0x06, 0x00, 0x00}; 

unsigned char Texte1[] = {'E', 's', 's', 'a', 'i', ' ', 'I', '2', 'C', ' ', 'e', 't', ' ', 'L', 'C', 'D'};
unsigned char Texte2[] = {'B', 'o', 'n', 'j', 'o', 'u', 'r', ' ', '!', ' ', ' ', ' ', ' ', ' ', ' ', ' '};
unsigned char Texte3[] = {' ', ' ', ' ', 'A', 'u', 'd', 'i', 'o', 'v', 'o', 'r', 'e', ' ', ' ', ' ', ' '};
unsigned char * TableauDeTextes[] = {Texte1, Texte2, Texte3};

unsigned char AdresseCurseurActuelle;
unsigned char EtatDesLED;

int NombreCaracteresRecus = 0;

unsigned char TableauCaracteresRecus[16] = {0};

void Delai(int t)	/*Fonction qui sert  faire perdre son temps au STM32F100RB*/
	{
		int i;
		for(i = 0; i < (10 * t); i++);
	}

void ConfigurerPortC()
	{
	 	RCC->APB2ENR |= (1 << 4);
		GPIOC->CRH = ((GPIOC->CRH & 0x00000000) | (0x00000033));
		GPIOC->CRL = ((GPIOC->CRL & 0x00000000) | (0x30000000));
	}

void Initialisation_I2C_1(void)
	{
		/* GPIOB clock enable */
		RCC->APB2ENR |= (1 << 3);

        /* I2C1 clock enable */
		RCC->APB1ENR |= (1 << 21);

        /* I2C1 SDA and SCL configuration */
		GPIOB->CRL = ((GPIOB->CRL & 0x00FFFFFF) | (0xFF000000));

        /* Enable I2C1 reset state */
		RCC->APB1RSTR |= (1 << 21);
        /* Release I2C1 from reset state */
		RCC->APB1RSTR &= ~(1 << 21);

		I2C1->CR1 = 0x0401;
		I2C1->CR2 = 0x0108;
		
		I2C1->SR1 = 0x0000;
		I2C1->SR2 = 0x0000;
		
		I2C1->CCR = 0x8006;
		
		I2C1->OAR1 = 0x4028;
		I2C1->OAR2 = 0x0000;
		
		I2C1->TRISE = 0x0003;
	}

int Ecrire16Nouvelle(unsigned char adresse, unsigned char commande, unsigned char donnee1, unsigned char donnee2) 
	{
		int temp = 0;
	    int Timeout = 0;
		int NumByteToWrite = 3;
		int p = 0;
		unsigned char Buffer_Test_1[3] = {0x00, 0x00, 0x00};
		Buffer_Test_1[0] = commande;
		Buffer_Test_1[1] = donnee1;
		Buffer_Test_1[2] = donnee2;
        Timeout = 0xFFFF;
        /* Send START condition */
        I2C1->CR1 |= 0x0100;
	        /* Wait until SB flag is set: EV5 */
	        while ((I2C1->SR1&0x0001) != 0x0001)
		        {
		            if (Timeout-- == 0)
						{
		 					Initialisation_I2C_1();
			                	return 0;
						}
		        }
        /* Send slave address */
        /* Reset the address bit0 for write*/
        adresse &= 0xFFFE;
        /* Send the slave address */
        I2C1->DR = adresse;
        Timeout = 0xFFFF;
	        /* Wait until ADDR is set: EV6 */
	        while ((I2C1->SR1 &0x0002) != 0x0002)
	        {
	            if (Timeout-- == 0)
					{
	 					Initialisation_I2C_1();
		                	return 0;
					}
	        }
        /* Clear ADDR flag by reading SR2 register */
        temp = I2C1->SR2;
        /* Write the first data in DR register (EV8_1) */
        I2C1->DR = Buffer_Test_1[0];
        /* Increment */
        p++;
        /* Decrement the number of bytes to be written */
        NumByteToWrite--;
	        /* While there is data to be written */
	        while (NumByteToWrite--)
		        {
		            /* Poll on BTF to receive data because in polling mode we can not guarantee the
		              EV8 software sequence is managed before the current byte transfer completes */
		            while ((I2C1->SR1 & 0x00004) != 0x000004);
		            /* Send the current byte */
		            I2C1->DR = Buffer_Test_1[p];
		            /* Point to the next byte to be written */
		            p++;
		        }
	        /* EV8_2: Wait until BTF is set before programming the STOP */
	        while ((I2C1->SR1 & 0x00004) != 0x000004);
	        /* Send STOP condition */
	    I2C1->CR1 |= 0x0200;
	        /* Make sure that the STOP bit is cleared by Hardware */
	        while ((I2C1->CR1&0x200) == 0x200);

		Delai(1000);
		Initialisation_I2C_1();	
	    	return 1;
	}

unsigned char Retourner(unsigned char paquet)	/*Fonction qui permet de remettre les donnes  l'endroit, avant de les envoyer aux broches  DB0    DB7  de l'afficheur alphanumrique*/
	{
		int k;
		unsigned char collecteur[8];
		unsigned char envers;
			envers = 0;
				for(k = 0; k < 8; k++)
					{
						collecteur[k] = ((paquet >> k) & 0x01);
					}
				for(k = 0; k < 8; k++)
					{
						envers |= (collecteur[7 - k] << k);
					}
		return envers;
	}

void Envoicommande(unsigned char commande)
	{
		commande = Retourner(commande);
			Ecrire16Nouvelle(AdresseCommande, 0x12, 0x00, ((EtatDesLED << 2 ) | 0x00));	/*PORTC = ((PORTC & 0xF8) | (0x00));*/	/*RS = 0, R/W = 0, E = 0*/
			Ecrire16Nouvelle(AdresseCommande, 0x12, commande, ((EtatDesLED << 2 ) & 0xF8));	/*PORTD = commande;*/	/*R/W = 0*/
			Ecrire16Nouvelle(AdresseCommande, 0x12, commande, ((EtatDesLED << 2 ) | 0x04));	/*PORTC = ((PORTC & 0xF8) | (0x04));*/ /*RS = 0, R/W = 0, E = 1*/
			Delai(30);
			Ecrire16Nouvelle(AdresseCommande, 0x12, commande, ((EtatDesLED << 2 ) & 0xF8));	/*PORTC = ((PORTC & 0xF8) | (0x00));*/	/*RS = 0, R/W = 0, E = 0*/
	}

void PlacerCurseur(unsigned char adresse_du_curseur)
	{
		Envoicommande(0x80 | adresse_du_curseur);
			AdresseCurseurActuelle = adresse_du_curseur;
	}

void EnvoiDonnee(unsigned char donnee)
	{
		donnee = Retourner(donnee);
		Ecrire16Nouvelle(AdresseCommande, 0x12, 0x00, ((EtatDesLED << 2 ) | 0x01));	/*PORTC = ((PORTC & 0xF8) | (0x01));*/	/*RS = 1*/
		Ecrire16Nouvelle(AdresseCommande, 0x12, donnee, ((EtatDesLED << 2 ) | 0x01));	/*PORTD = donnee;*/	/*RS = 1*/
		Ecrire16Nouvelle(AdresseCommande, 0x12, donnee, ((EtatDesLED << 2 ) | 0x05));	/*PORTC = ((PORTC & 0xF8) | (0x05));*/	/*RS = 1, E = 1*/
		Delai(30);
		Ecrire16Nouvelle(AdresseCommande, 0x12, donnee, ((EtatDesLED << 2 ) | 0x01));	/*PORTC = ((PORTC & 0xF8) | (0x01));*/	/*RS = 1*/
	}

void InitialisationAfficheur(void)
	{
		int k;
		unsigned char commandes_pour_initialisation[5] = {0x01, 0x38, 0x0C, 0x06, 0x02};
			/*PORTC = 0x00;*/
			/*PORTD = 0x00;*/
				for(k = 0; k < 5; k++)
					{
						Envoicommande(commandes_pour_initialisation[k]);
					}
	}

void MiseVeilleAfficheur(void)
	{
		int k;
		unsigned char commandes_pour_veille[3] = {0x01, 0x02, 0x08};
			/*PORTC = 0x00;*/
			/*PORTD = 0x00;*/
				for(k = 0; k < 3; k++)
					{
						Envoicommande(commandes_pour_veille[k]);
					}
	}

unsigned char ObtenirAdresseActuelle(void)
	{
		unsigned char valeur_adresse_obtenue, c;
			c = 0;
			Ecrire16Nouvelle(AdresseCommande, 0x00, 0xFF, 0x00); 	/*TRISD = 0xFF;*/
			Ecrire16Nouvelle(AdresseCommande, 0x12, 0x00, ((EtatDesLED << 2 ) | 0x06));	/*PORTC = ((PORTC & 0xF8) | (0x06));*/	/*RS = 0, R/W = 1, E = 1*/
			Delai(30);
			/*Lire16Nouvelle(AdresseCommande, 0x12, (AdresseCommande | 0x01), &valeur_adresse_obtenue, &c);*/	/*valeur_adresse_obtenue = PORTD;*/	/*RS = 0, R/W = 1, E = 1*/
			Ecrire16Nouvelle(AdresseCommande, 0x00, 0x00, 0x00);	/*TRISD = 0x00;*/
			Ecrire16Nouvelle(AdresseCommande, 0x12, 0x00, ((EtatDesLED << 2 ) | 0x02));	/*PORTC = ((PORTC & 0xF8) | (0x02));*/	/*RS = 0, R/W = 1, E = 0*/
			valeur_adresse_obtenue = Retourner(valeur_adresse_obtenue);
			valeur_adresse_obtenue = AdresseCurseurActuelle;
		return valeur_adresse_obtenue;
	}

void AfficheCaractere(unsigned char c)
	{
		EnvoiDonnee(c);
		AdresseCurseurActuelle++;
		if(ObtenirAdresseActuelle() == 0x08)
			{
				PlacerCurseur(0x28);
			}
	}

void AfficheTexte(unsigned char * texte)
	{
		int i = 0;
		while (texte[i] != '\0')
			{
				AfficheCaractere(texte[i]);
					i++;
			}
	}

void ConfigurerUSART1()
	{
	 	RCC->APB2ENR |= 0x00000001;	/*Activation de l'horloge pour les fonctions d'entres-sorties alternatives*/
		AFIO->MAPR &= ~(1 << 2); /*Remise  zro du USART 1 remap*/
		RCC->APB2ENR |= 0x00000004;	/*Activation de l'horloge du port GPIOA*/
		GPIOA->CRH = ((GPIOA->CRH & 0xFFFFF00F) | (0x000004B0));	/*USART 1 Tx se situe sur la broche PA9,
																	qui doit tre configure en  Alternate Output Push-Pull ,
																	USART 1 Rx se situe sur la broche PA10,
																	qui doit tre configure en  Input Floating */
		RCC->APB2ENR |= 0x00004000;	/*Activation de l'horloge de l'USART 1*/
		USART1->BRR = 8000000 / 115200;	/*USART1->BRR = 0b1000100* : USARTDIV 1 = 4 + (5 / 16) = 4,3125*/
		USART1->CR1 = 0;
		USART1->CR2 = 0;
		USART1->CR3 = 0;
		USART1->CR1 |= 0x0000000C;
		USART1->CR1 |= 0x00002000;
		USART1->CR1 |= (1 << 5); /*Activation de l'interruption de l'USART 1, lors de la rception d'un octet*/
	}

int ObtenirOctetRecu()	/*Fonction qui attend que l'USART 1 a reu une donne pour renvoyer cette donne*/
	{
		while (!(USART1->SR & USART_FLAG_RXNE));	/*On attend que l'USART 1 signale la rception d'un octet*/
		return ((int)(USART1->DR & 0x1FF));	/*L'octet que l'USART 1 a recu se trouve dans le registre  USART1->DR */
	}

void EnvoyerOctet(unsigned char donnee)	/*Permet d'envoyer un octer par l'USART 1*/ 
	{
		while (!(USART1->SR & USART_FLAG_TXE));	/*On attend que l'USART 1 soit prt  envoyer une donne*/
			USART1->DR = donnee;	/*L'envoi de l'octet par l'USART 1 dmarre quand on crit l'octet dans le registre  USART1->DR */
	}

void EnvoyerPlusieursOctets(unsigned char *paquet)	/*Permet d'envoyer une chane de caractres par l'USART 1*/
	{
        while(*paquet != '\0')	/*Tant que l'on est pas arriv  la fin de la chane de caractres*/
			{
				EnvoyerOctet(*paquet);	/*On envoie le caractre courant de la chane de caractres*/
				paquet++;
			}
	}

void USART1_IRQHandler(void) __irq	/*Fonction appele lorsque l'USART 1 provoque une interruption*/
	{	
		int reception;
		int k;	 
			if((USART1->SR & USART_FLAG_RXNE))
				{
					reception = (int)(USART1->DR & 0x1FF);	/*La donne reue par l'USART 1 est mise dans la variable  reception */
					TableauCaracteresRecus[NombreCaracteresRecus] = reception;
					NombreCaracteresRecus++;
						if(reception == 0x0D)	/*Si la donne reue correspond  un retour chariot*/
							{
								Envoicommande(0x01);	/*Effacement de l'afficheur LCD*/
								PlacerCurseur(0x00);
									for(k = 0; k < (NombreCaracteresRecus - 1); k++)
										{
											AfficheCaractere(TableauCaracteresRecus[k]);	/*On affiche les donnes reues, l'une aprs l'autre, sur l'afficheur alphanumrique*/
										}
								EnvoyerPlusieursOctets("Donnes bien affiches !\r");	/*Envoi d'un accus de rception et d'affichage des donnes*/
								NombreCaracteresRecus = 0;	/*Remise  zro du nombre de caractres reus, pour se prparer  la rception d'autres donnes*/
							}
				}
		USART1->SR = 0;	/*Rarmement de l'interruption provoque par l'USART 1*/	
	}

void initITUSART1()	/*Fonction qui permet d'autoriser l'interruption provoque par l'USART 1*/
	{
		NVIC->ISER[1] |= (1 << (USART1_IRQChannel & 0x1F));	/*NVIC->ISER[1] |= (1 << 5);*/
	}

int main (void)
	{
 		ConfigurerPortC();	/*Configuration des broches relies  la LED verte et  la LED bleue*/	
		AdresseCurseurActuelle = 0;

    	Initialisation_I2C_1();

		Ecrire16Nouvelle(AdresseCommande, 0x00, 0x00, 0x00);	/*Configuration des 16 broches du circuit intgr MCP23017 en sorties*/
		Ecrire16Nouvelle(AdresseCommande, 0x12, 0x00, 0x00);	/*Mise de chacune des 16 broches du circuit intgr MCP23017   0 */

		EtatDesLED = 0x00;

		InitialisationAfficheur();
		PlacerCurseur(0x00);
		AfficheTexte(TableauDeTextes[1]);

		ConfigurerUSART1();	/*Configuration de l'USART 1 : 115200 bauds*/
		initITUSART1();	/*Autorisation de l'interruption provoque par l'USART 1*/
		EnvoyerPlusieursOctets("Bonjour !\r");	/*Envoi d'un message pour montrer que la communication est fonctionnelle dans le sens STM32F100RB -> Ordinateur, via les modules XBee*/
				while(1)
					{
						GPIOC->ODR |= 0x00000200; /*Allumage de la LED verte*/
						Delai(10000);
						GPIOC->ODR &= ~(0x00000200); /*Extinction de la LED verte*/
						Delai(10000);	
					}
	}

void SystemInit (void)
	{
	
	}
